local StarCreater
local Graphic
local AnimationFactory

local HoldSousuo
local HoldOpen

local MainWndMousePos = {}
local LastMainWndMousePos = {}

function getMousePos()
	return MainWndMousePos.x, MainWndMousePos.y
end

function getLastMousePos()
	return LastMainWndMousePos.x, LastMainWndMousePos.y
end

function getSousuoPos()
	return 210,200,455,230 
end

function getOpenPos()
	return 460,200,545,230 
end

function getHoldSousuoPos()
	if HoldSousuo then
		local l,t,r,b = getSousuoPos()
		return getStarCreater():RandomInteger(l,r), getStarCreater():RandomInteger(t,b)
	end
	return -9999,-9999
end

function getHoldOpenPos()
	if HoldOpen then
		local l,t,r,b = getOpenPos()
		return getStarCreater():RandomInteger(l,r), getStarCreater():RandomInteger(t,b)
	end
	return -9999,-9999
end

function MainWnd_OnLButtonDown(...)
	local args = {...}
	local self,x,y = args[1],args[2],args[3]
	local l,t,r,b = getSousuoPos()
	if x > l and x < r and y > t and y < b then
		HoldSousuo = true
		HoldOpen = false
		return 
	end
	l,t,r,b = getOpenPos()
	if x > l and x < r and y > t and y < b then
		HoldOpen = true
		HoldSousuo = false
		return 
	end
	HoldOpen = false
	HoldSousuo = false
end

function MainWnd_OnLButtonUp(...)
	local args = {...}
	local self,x,y = args[1],args[2],args[3]
	--HoldSousuo = false
	--HoldOpen = false
end



function getAnimationFactory()
	if not AnimationFactory then
		AnimationFactory = XLGetObject("Xunlei.UIEngine.AnimationFactory")
	end
	return AnimationFactory
end

function getStarCreater()
	if not StarCreater then
		local af = getAnimationFactory()
		StarCreater = af:CreateAnimation("SingleStarCreater")
	end
	return StarCreater
end

function getGraphic()
	if not Graphic then
		Graphic = XLGetObject("Xunlei.XLGraphic.Factory.Object")
	end
	return Graphic
end

function createRandomStar(self,x,y)
	local graphic = getGraphic()
	local star_creater = getStarCreater()
	
	local rate = star_creater:RandomNumber(0.1,1)
	
	local color1 = graphic:CreateColor(255,255,255,75)
	local ani,obj = star_creater:CreateInstanceAndObj(nil,"Static",self,x,y,x + 50,
		y + 50,1000,rate,0,color1)
	star_creater:CreateInstance(ani,"Flash",10 * rate,20 * rate,
		star_creater:RandomInteger(1000,3000),star_creater:RandomNumber(0,1))
	star_creater:CreateInstance(ani,"Disapear",255)
	star_creater:CreateInstance(ani,"Float",{["x"] = x,["y"] = y},{["x"] = x,["y"] = -50},
		star_creater:RandomInteger(1000,3000),star_creater:RandomInteger(0,50) * rate,
		star_creater:RandomInteger(3000,7000),star_creater:RandomNumber(0,1),true)
	star_creater:CreateInstance(ani,"Hotpoint",getMousePos,150,-4,graphic:CreateColor(0,255,255,150))
	
	star_creater:CreateInstance(ani,"Hotpoint",getHoldSousuoPos,500,-10,graphic:CreateColor(255,0,255,150))
	star_creater:CreateInstance(ani,"Hotpoint",getHoldOpenPos,500,-10,graphic:CreateColor(255,255,0,150))

	star_creater:CreateInstance(ani,"HotRect_Static",getOpenPos,graphic:CreateColor(255,0,255,150))
	--star_creater:CreateInstance(ani,"HotRect_Satellete",function() return 210,190,455,230 end,100,3000,graphic:CreateColor(255,255,0,150))
	star_creater:CreateInstance(ani,"HotRect_Satellete",getSousuoPos, 100,2500,graphic:CreateColor(255,255,0,150))
	ani:Resume()
end

function MainWnd_OnMouseMove(...)
	local args = {...}
	local self,x,y = args[1],args[2],args[3]
	if MainWndMousePos.x and MainWndMousePos.y then
		LastMainWndMousePos.x = MainWndMousePos.x
		LastMainWndMousePos.y = MainWndMousePos.y
	end
	MainWndMousePos.x = x
	MainWndMousePos.y = y
end

function MainWnd_OnInitControl(...)
	local args = {...}
	local self = args[1]
	local af = getAnimationFactory()
	function CreateFuncDef(obj) 
		return function(x,y)
			return createRandomStar(obj,x,y)
		end
	end
	function PositionFuncDef(obj)
		local l,t,r,b = obj:GetObjPos()
		local w = r - l
		local h = b - t
		local star_creater = getStarCreater()
		return function()
			return star_creater:RandomInteger(50,160),star_creater:RandomInteger(170,210)
		end
	end
	local fs = af:CreateAnimation("FireStarsAni")
	local fs_attr = fs:GetAttribute()
	fs_attr.Speed = 5
	fs.SetCreateFunc(fs,CreateFuncDef(self))
	fs.SetPositionFunc(fs,PositionFuncDef(self))
	fs:BindObj(self)
	local tree = self:GetOwner()
	tree:AddAnimation(fs)
	fs:Resume()
end