-- Single Star Animatin methods ; flash function , move function should be defined in template or creater
function SingleStar_LightFlash(ani)
	local attr = ani:GetAttribute()
	if attr.flash_func then
		local radii = attr.flash_func(ani)
		local clr
		if attr.light_color_func then
			clr = attr.light_color_func(ani)
		else
			clr = attr.light_color
		end
		local r,g,b,a = attr.light_color:GetRGBAValues()
		attr.light_att_color = attr.graphic:CreateColor(b,g,r,0)
		attr.fill_obj:SetSrcColor(attr.light_color)
		attr.fill_obj:SetDestColor(attr.light_att_color)
		attr.fill_obj:SetDestPt(math.floor(attr.centre.x + radii),math.floor(attr.centre.y + radii))
		local l,t,r,b = attr.image_obj:GetObjPos()
		local w = r - l
		local h = b - t
		--attr.image_obj:PushDirtyRect(0,0,w,h)
	end
end

function SingleStar_Move(ani)
	local attr = ani:GetAttribute()
	if attr.move_func then
		local x,y,z = attr.move_func(ani)
		--XLLog("[stars] x y : "..x.." "..y.." \r\n")
		local l,t,r,b = attr.image_obj:GetObjPos()
		attr.image_obj:SetObjPos(x,y,x + r - l,y + b - t)
		if z then
			attr.image_obj:SetZorder(z)
		end
	end
end

function SingleStar_AlphaChange(ani)
	local attr = ani:GetAttribute()
	if attr.alpha_func then
		local alpha = attr.alpha_func(ani)
		attr.image_obj:SetAlpha(alpha)
		attr.star_obj:SetAlpha(alpha)
		attr.fill_obj:SetAlpha(alpha)
	end
end

function SingleStar_Init(ani)
	local attr = ani:GetAttribute()
	local graphic = XLGetObject("Xunlei.XLGraphic.Factory.Object")
	local xar = XLGetObject("Xunlei.UIEngine.XARManager")
	local obj_factory = XLGetObject("Xunlei.UIEngine.ObjectFactory")
	
	attr.blank_color = graphic:CreateColor(0,0,0,0)
	
	local l,t,r,b = attr.image_obj:GetObjPos()
	
	attr.centre = {}
	attr.centre.x = (r - l) / 2
	attr.centre.y = (b - t) / 2
	
	
	attr.fill_obj = obj_factory:CreateUIObject("","FillObject")
	attr.fill_obj:SetFillType("Circle")
	attr.fill_obj:SetBlendType("Source")
	attr.fill_obj:SetSrcPt(math.floor(attr.centre.x),math.floor(attr.centre.y))
	
	attr.fill_obj:SetObjPos(0,0,r - l,b - t)
	attr.fill_obj:SetZorder(-99)
	attr.image_obj:AddChild(attr.fill_obj)
	

	
	if not attr.light_color then
		attr.light_color = xar:GetColor(attr.LightColorId)
	end
	
	attr.star_obj = obj_factory:CreateUIObject("","ImageObject")
	
	local star_img = xar:GetBitmap(attr.StarImage)
	attr.star_obj:SetBitmap(star_img)
	
	local ct,w,h = star_img:GetInfo()
	attr.image_obj:AddChild(attr.star_obj)
	attr.star_obj:SetZorder(-98)
	attr.star_obj:SetObjPos(attr.centre.x - w / 2,attr.centre.y - h / 2,attr.centre.x + w / 2,attr.centre.y + h / 2)
	local rotate_ani = XLGetObject("Xunlei.UIEngine.AnimationFactory"):CreateAnimation("AngleChangeAnimation")
	rotate_ani:SetKeyFrameAngle(0,0,0,0,0,-360 * 9999999)
	rotate_ani:SetKeyFrameRange(attr.StarRate,attr.StarRate,attr.StarRate,attr.StarRate,attr.StarRate,attr.StarRate)
	rotate_ani:SetTotalTime(attr.StarRotateCyc * 9999999)
	rotate_ani:BindObj(attr.star_obj)
	rotate_ani:SetCentrePointMode("WidthHeightRate")
	rotate_ani:SetCentrePoint(60,60)
	attr.tree:AddAnimation(rotate_ani)
	local rotate_ani_meta = rotate_ani.__index
	rotate_ani_meta.star_ani = ani
	rotate_ani:Resume()
	attr.rotate_ani = rotate_ani
	
	attr.graphic = graphic
	
	
	if not attr.move_func then
		attr.move_func = loadstring(attr.MoveFuncDef)
	end
	if not attr.flash_func then
		attr.flash_func = loadstring(attr.FlashFuncDef)
	end
	if not attr.alpha_func then
		attr.alpha_func = loadstring(attr.AlphaFuncDef)
	end
end

function SingleStar_OnRotateFinish(rotate_ani,old,new)
	if new == 4 then
		local ani = rotate_ani.star_ani
		local attr = ani:GetAttribute()
		--attr.image_obj:RemoveChild(attr.star_obj)
	end
end

function SingleStar_Uninit(ani)
	local attr = ani:GetAttribute()
	attr.rotate_ani:ForceStop()
	attr.image_obj:RemoveChild(attr.star_obj)
	attr.image_obj:RemoveChild(attr.fill_obj)
end

function SingleStar_OnEvent(ani,old,new)
	if new == 2 then
		SingleStar_Init(ani)
	end
	if new == 4 then
		SingleStar_Uninit(ani)
	end
end

function SingleStar_BindObj(ani,obj)
	local attr = ani:GetAttribute()
	attr.image_obj = obj
	attr.tree = obj:GetOwner()
	ani:AttachListener(true,SingleStar_OnEvent)
end

function SingleStar_Action(ani)
	SingleStar_LightFlash(ani)
	SingleStar_Move(ani)
	SingleStar_AlphaChange(ani)
end


function SingleStar_SetFlashFunc(ani,func)
	local attr = ani:GetAttribute()
	attr.flash_func = func
end

function SingleStar_GetFlashFunc(ani)
	local attr = ani:GetAttribute()
	return attr.flash_func
end

function SingleStar_SetMoveFunc(ani,func)
	local attr = ani:GetAttribute()
	attr.move_func = func
end

function SingleStar_GetMoveFunc(ani)
	local attr = ani:GetMoveFunc()
	return attr.move_func
end

function SingleStar_SetLightColor(ani,clr)
	local attr = ani:GetAttribute()
	attr.light_color = clr
end

function SingleStar_GetLightColor(ani)
	local attr = ani:GetAttribute()
	return attr.light_color
end

function SingleStar_SetLightColorFunc(ani,func)
	local attr = ani:GetAttribute()
	attr.light_color_func = func
end

function SingleStar_GetAlphaFunc(ani)
	local attr = ani:GetAttribute()
	return attr.alpha_func
end

function SingleStar_SetAlphaFunc(ani,func)
	local attr = ani:GetAttribute()
	attr.alpha_func = func
end

-- creater for single stars , call create instance to create an single star animation instance 
-- on intended postion; add deferent single star animation to the creater 
function SingleStarCreater_Init(ctr)
	local attr = ctr:GetAttribute()
	if attr.inited then
		return
	end
	attr.creaters = {}
	attr.template_manager = XLGetObject("Xunlei.UIEngine.TemplateManager")
	attr.animation_factory = XLGetObject("Xunlei.UIEngine.AnimationFactory")
	attr.obj_factory = XLGetObject("Xunlei.UIEngine.ObjectFactory")
	attr.inited = true
	
	attr.max_zorder = 1000
	attr.min_zorder = 100
	attr.zorder_step = 4
	attr.cur_zorder = attr.min_zorder
	----define pre defined star prototypes 
	ctr:AddCreateFunc("Static",
		function(base,StarCyc,Rate,StarOffset,Color,Alpha,Radii,StartPos,EndPos,TotalTime)
			local ani = ctr:RawCreateInstance(base)
			local ani_attr = ani:GetAttribute()
			if TotalTime then
				ani:SetTotalTime(TotalTime)
			end
			if Color then
				ani:SetLightColor(Color)
			end
			if Radii then
				ani:SetFlashFunc(function() return Radii end)
			end
			if Alpha then
				ani:SetAlphaFunc(function() return Alpha end)
			end
			if StartPos and EndPos then
			ani:SetMoveFunc(function(ani) return StartPos.x + (EndPos.x - StartPos.x) * ani:GetRuningTime() / TotalTime,StartPos.y + (EndPos.y - StartPos.y) * ani:GetRuningTime() / TotalTime end)
			end
			if Rate then
				ani_attr.StarRate = Rate
			end
			if StarCyc then
				ani_attr.StarRotateCyc = StarCyc
			end
			if StarOffset then
				ani_attr.StarRotateOffset = StarOffset
			end
			return ani
		end)
	ctr:AddCreateFunc("RandomStatic", 
	function(base,MinRadii,MaxRadii,MinStarCyc,MaxStarCyc,MinRate,MaxRate,MinAlpha,MaxAlpha,MinTotalTime,MaxTotalTime,StartPos,EndPos)
		local graphic = XLGetObject("Xunlei.XLGraphic.Factory.Object")
		local color = graphic:CreateColor(math.random(0,255),math.random(0,255),math.random(0,255),255)
		local radii = math.random(MinRadii,MaxRadii)
		local star_cyc = math.random(MinStarCyc,MaxStarCyc)
		local rate = (math.random(MinRate * 100,MaxRate * 100)) / 100 
		local alpha = math.random(MinAlpha,MaxAlpha)
		local tt = math.random(MinTotalTime,MaxTotalTime)
		return ctr:CreateInstance(base,"Static",radii,color,star_cyc,rate,alpha,StartPos,EndPos,tt)
	end)
	ctr:AddCreateFunc("Flash",
	function(base,MinRadii,MaxRadii,FlashCyc,Offset)
		local ani = ctr:RawCreateInstance(base)
		if not Offset then
			Offset = 0
		end
		ani:SetFlashFunc(function(ani) return MinRadii + (MaxRadii - MinRadii) * math.abs(math.sin(-2 * math.pi * (ani:GetRuningTime() / FlashCyc + Offset))) end)
	end)
	ctr:AddCreateFunc("Disapear",
	function(base,alpha)
		local ani = ctr:RawCreateInstance(base)
		ani:SetAlphaFunc(function(ani) return alpha - alpha * ani:GetRuningTime() / ani:GetTotalTime() end)
		end)
		
	ctr:AddCreateFunc("Float",
	function(base,StartPos,EndPos,FloatCyc,FloatDistance,TotalTime,Offset,Damping)
		local ani = ctr:RawCreateInstance(base)
		--local dis =  ((EndPos.x - StartPos.x) ^ 2 + (EndPos.y - StartPos.y) ^ 2) ^ 0.5
		--local dis_cyc = dis * FloatCyc / TotalTime
		ani:SetTotalTime(TotalTime)
		if not Offset then
			Offset = 0
		end
		local damp_param = function(ani) return 1 end
		if Damping then
			damp_param = function(ani) return 1 - ani:GetRuningTime() / TotalTime end 
		end
		--if EndPos.x == StartPos.x then
			ani:SetMoveFunc(function(ani) 
				local y = StartPos.y + (EndPos.y - StartPos.y) * ani:GetRuningTime() / TotalTime
				local x = StartPos.x + FloatDistance * damp_param(ani) * math.sin(2 * math.pi * (Offset + ani:GetRuningTime() / FloatCyc))
				return x,y 
				end)
		--end
	end)
	
	ctr:AddCreateFunc("Hotpoint",
	function(base,Centre,Radii,Speed,Color,ColorFunc)
		local ani = ctr:RawCreateInstance(base)
		local sqr_radii = Radii ^ 2
		local total_cx = 0
		local total_cy = 0
		
		local ani_attr = ani:GetAttribute()
		local old_move_func = ani_attr.move_func
		local old_color = ani_attr.light_color
		ani:SetMoveFunc(function(ani)
			ani_attr.light_color = old_color
			local hx,hy = Centre()
			if not (hx and hy) then
				return old_move_func(ani)
			end
			local l,t,r,b = ani_attr.image_obj:GetObjPos()
			local cl = (l + r) / 2
			local ct = (t + b) / 2
			local disx = cl - hx
			local disy = ct - hy
			local sqr_dis = (disx^2 + disy^2)
			if sqr_dis == 0 then
				return l,t
			end
			if sqr_dis < sqr_radii then
				local dis = sqr_dis ^ 0.5
				local cx = Speed * disx / dis
				local cy = Speed * disy / dis
				total_cx = total_cx + cx
				total_cy = total_cy + cy
				if Color then
					ani_attr.light_color = Color
				end
			end
			local x,y = old_move_func(ani)
			return x + total_cx, y + total_cy
		end)
	end)
	
	ctr:AddCreateFunc("HotRect",
	function(base,HotRect,HotMoveFunc)
		local ani = ctr:RawCreateInstance(base)
		local ani_attr = ani:GetAttribute()
		local old_move_func = ani_attr.move_func
		
		ani:SetMoveFunc(function(ani)
			local l,t,r,b = ani_attr.image_obj:GetObjPos()
			local sw = (r - l) / 2
			local sh = (b - t) / 2
			l = l + sw
			t = t + sh
			local hl,ht,hr,hb = HotRect()
			local cx,cy = old_move_func(ani)
			cx = cx + sw
			cy = cy + sh
			
			--XLLog("[stars] rect "..hl.." "..ht.." "..hr.." "..hb.."\r\n")
			
			if math.min(cx,l) > hr or math.min(cy,t) > hb or math.max(cx,l) < hl or math.max(cy,t) < ht then
				return cx - sw, cy - sh
			end
			if l > hl and l < hr and t > ht and t < hb then
				return cx - sw, cy - sh
			end
			if cx == l then
				if cy > t then
					if cy >= ht then
						return HotMoveFunc(ani,cx,ht,cx,hb)
					else 
						return cx - sw,cy - sh
					end
				elseif cy < t then
					if cy <= hb then
						return HotMoveFunc(ani,cx,hb,cx,ht)
					else
						return cx - sw,cy - sh
					end
				end
				return cx - sw,cy - sh
			end
			if cy == t then
				if cx > l then
					if cx >= hl then
						return HotMoveFunc(ani,hl,cy,hr,cy)
					else
						return cx - sw,cy - sh
					end
				elseif cx < l then
					if cx <= hr then
						return HotMoveFunc(ani,hr,cy,hl,cy)
					else
						return cx - sw,cy - sh
					end
				end
				return cx - sw,cy - sh
			end
			local lk = (cy - t) / (cx - l)
			local lb = cy - cx * lk
			local ly = lk * hl + lb
			local ry = lk * hr + lb 
			local tx = (ht - lb) / lk
			local bx = (hb - lb) / lk
			
			--XLLog("[stars] may cross \r\n")
			--XLLog("[stars] cx "..cx.."  cy  "..cy.." l "..l.." t "..t.." \r\n")
			
			local temp1 = {["x"] = 999999,["y"] = 0}
			local temp2 = {["x"] = -999999,["y"] = 0}
			local is_cross
			function addCross(a,b,c,d,e)
				if e >= c and e <= d then
					if a < temp1.x then
						temp1.x = a
						temp1.y = b
					end
					if a > temp2.x then
						temp2.x = a
						temp2.y = b
					end
					is_cross = true
					--XLLog("[stars] find cross "..a.."  "..b.."  \r\n")
				end
			end
			
			addCross(hl,ly,ht,hb,ly)
			addCross(hr,ry,ht,hb,ry)
			addCross(tx,ht,hl,hr,tx)
			addCross(bx,hb,hl,hr,bx) 
			
			if is_cross then
				if cx > l then
					return HotMoveFunc(ani,temp1.x,temp1.y,temp2.x,temp2.y)
				elseif cx < l then
					return HotMoveFunc(ani,temp2.x,temp2.y,temp1.x,temp1.y)
				else 
					return HotMoveFunc(ani,cx,cy,cx,cy)
				end
			else
				return cx - sw,cy - sh
			end
		end)
	end)
	
	ctr:AddCreateFunc("HotRect_Static",
	function(ani,HotRect,color)
		return ctr:CreateInstance(ani,"HotRect",HotRect,function(ani,cx,cy,cx2,cy2)
			local ani_attr = ani:GetAttribute()
			if color then
				ani_attr.light_color = color
			end
			local l,t,r,b = ani_attr.image_obj:GetObjPos()
			local sw = (r - l) / 2
			local sh = (b - t) / 2
			ani_attr.move_func = function(ani) return cx - sw,cy - sh end
			return ani_attr.move_func(ani)
		end) 
	end)
	
	ctr:AddCreateFunc("HotRect_Satellete",
	function(ani,HotRect,hz,cyc,color)
		return ctr:CreateInstance(ani,"HotRect",HotRect,
			function(ani,cx,cy,cx2,cy2)
				local ani_attr = ani:GetAttribute()
				if color then
					ani_attr.light_color = color
				end
				local rt = ani:GetRuningTime()
				ani_attr.move_func = 
				function(ani)
					local l,t,r,b = ani_attr.image_obj:GetObjPos()
					local sw = (r - l) / 2
					local sh = (b - t) / 2
					local t = ani:GetRuningTime()
					local prg = - math.cos(-2 * math.pi * (t - rt) / cyc)
					local z
					if prg > 0 then
						z = hz + 1
					else
						z = hz - 1
					end
					return ((cx2 + cx) + (cx2 - cx) * prg) / 2 - sw, ((cy2 + cy) + (cy2 - cy) * prg) / 2 - sh, z
				end
				return ani_attr.move_func(ani)
			end)
	end)
end

function SingleStarCreater_RandomInteger(ctr,n1,n2)
	return math.random(n1,n2)
end

function SingleStarCreater_RandomNumber(ctr,n1,n2)
	return ctr:RandomInteger(n1 * 100,n2 * 100) / 100 
end

function SingleStarCreater_RandomColor(ctr,c1,c2)
	local r1,g1,b1,a1 = c1:GetRGBAValues(c1)
	local r2,g2,b2,a2 = c2:GetRGBAValues(c2)
	local graphic = XLGetObject("Xunlei.XLGraphic.Factory.Object")
	return graphic:CreateColor(ctr:RandomInteger(math.min(r1,r2),math.max(r1,r2)),ctr:RandomInteger(math.min(g1,g2),math.max(g1,g2)),ctr:RandomInteger(math.min(b1,b2),math.max(b1,b2)),ctr:RandomInteger(math.min(a1,a2),math.max(a1,a2)))
end

function SingleStarCreater_AddProtoFromTemplate(ctr,id,tid)
	SingleStarCreater_Init(ctr)
	local attr = ctr:GetAttribute()
	local cn = {}
	cn.type = "t"
	cn.tid = tid
	attr.creaters[id] = cn
end

function SingleStarCreater_AddProtoFromInstance(ctr,id,proto)
	SingleStarCreater_Init(ctr)
	local cn = {}
	cn.type = "p"
	cn.proto = proto
	attr.creaters[id] = cn
end

function SingleStarCreater_AddCreateFunc(ctr,id,func)
	SingleStarCreater_Init(ctr)
	local attr = ctr:GetAttribute()
	local cn = {}
	cn.type = "f"
	cn.func = func
	attr.creaters[id] = cn
end

function SingleStarCreater_RawCreateInstance(ctr,base)
	if base then 
		return base
	end
	local ins = XLGetObject("Xunlei.UIEngine.AnimationFactory"):CreateAnimation("SingleStarAni")
	ins:SetTotalTime(999999)
	return ins
end

function SingleStarCreater_CreateInstance(ctr,base,id,...)
	SingleStarCreater_Init(ctr)
	local attr = ctr:GetAttribute()
	local cn = attr.creaters[id]
	if not cn then
		return nil
	end
	if cn.type == "t" or cn.type == "p" then
		local proto_attr
		if cn.type == "t" then
			local tp = attr.template_manager:GetTemplate(cn.tid,"AnimationTemplate")
			local proto = tp.CreateInstance()
			proto_attr = proto:GetAttribute()
		else 
			proto_attr = cn.proto:GetAttribute()
		end
		local ins = SingleStarCreater_RawCreateInstance(ctr,base)
		local ins_attr = ins:GetAttribute()
		for k,v in pairs(proto_attr) do
			ins_attr[k] = proto_attr[k]
		end
		return ins
	end
	if cn.type == "f" then
		return cn.func(base,...)
	end
end

function SingleStarCreater_CreateInstanceAndObj(ctr,base,id,father,left,top,right,bottom,...)
	SingleStarCreater_Init(ctr)
	local attr = ctr:GetAttribute()
	local obj = attr.obj_factory:CreateUIObject("","ImageObject")
	father:AddChild(obj)
	obj:SetObjPos(left,top,right,bottom)
	obj:SetZorder(attr.cur_zorder)
	attr.cur_zorder = attr.cur_zorder + attr.zorder_step
	if attr.cur_zorder == attr.max_zorder then
		attr.cur_zorder = attr.min_zorder
	end
	local ins = ctr:CreateInstanceOnObj(base,id,obj,...)
	ins:AttachListener(true,SingleStarCreater_OnInstanceFinish)
	return ins, obj
end

function SingleStarCreater_OnInstanceFinish(ani,old,new)
	if new == 4 then
		local ani_attr = ani:GetAttribute()
		local obj = ani_attr.image_obj
		local father = obj:GetFather()
		father:RemoveChild(obj)
	end
end

function SingleStarCreater_CreateInstanceOnObj(ctr,base,id,obj,...)
	SingleStarCreater_Init(ctr)
	local attr = ctr:GetAttribute()
	local ins = SingleStarCreater_CreateInstance(ctr,base,id,...)
	ins:BindObj(obj)
	local tree = obj:GetOwner()
	tree:AddAnimation(ins)
	return ins
end

function FireStarsAni_SetCreateFunc(ani,func)
	local attr = ani:GetAttribute()
	attr.create_func = func
end

function FireStarsAni_SetPositionFunc(ani,func)
	local attr = ani:GetAttribute()
	attr.pos_func = func
end

function FireStarsAni_Action(ani)
	local attr = ani:GetAttribute()
	if attr.time_count == attr.Speed then
		local x,y = attr.pos_func()
		attr.create_func(x,y)
		attr.time_count = 0
	end
	attr.time_count = attr.time_count + 1
end

function FireStarsAni_BindObj(ani,obj)
	local attr = ani:GetAttribute()
	attr.obj = obj
	ani:AttachListener(true,FireStarsAni_OnEvent)
end

function FireStarsAni_OnEvent(ani,old,new)
	if new == 2 then
		FireStarsAni_Init(ani)
	end
end

function FireStarsAni_Init(ani)
	ani:SetTotalTime(999999999)
	local attr = ani:GetAttribute()
	attr.time_count = 1
end

